import xe, { useContext as bt, Children as mt, isValidElement as Ke, useMemo as Z, useRef as ae, useLayoutEffect as yt, forwardRef as Ot, useEffect as Pt, useCallback as _e, useState as Ze, createElement as Tt } from "react";
const K = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var $ = /* @__PURE__ */ ((a) => (a.LABEL = "__label__", a.VALUE = "__value__", a))($ || {});
const qe = "mk-input", Ge = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: []
};
class St {
  constructor(t, r) {
    this.raw = t, this.uniRegExp = r, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let t = this.uniRegExp.exec(this.raw);
    if (t === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [r, n, i] = this.extractSlices(t);
    return this.raw = i, { done: !1, value: [r, n] };
  }
  extractSlices(t) {
    const r = this.extractMark(t), n = r.input.substring(0, r.index), i = r.input.substring(r.index + r.annotation.length);
    return [n, r, i];
  }
  extractMark(t) {
    let r = t[0], n = 0, i = t[1], c = t[2];
    for (; !(i || c); )
      n++, i = t[2 * n + 1], c = t[2 * n + 2];
    let v = t.index, u = t.input;
    return { annotation: r, label: i, value: c, input: u, index: v, childIndex: n };
  }
}
class oe {
  get regExps() {
    return this.markups.map(kt);
  }
  static split(t, r) {
    const n = r.map((i) => i.markup);
    return () => new oe(n).split(t);
  }
  constructor(t) {
    this.markups = t, this.uniRegExp = new RegExp(this.regExps.map((r) => r.source).join("|"));
  }
  split(t) {
    return this.iterateMatches(t);
  }
  iterateMatches(t) {
    const r = [];
    for (let [n, i] of new St(t, this.uniRegExp))
      r.push(n), i !== null && r.push(At(i, this.markups[i.childIndex]));
    return r;
  }
}
const Re = Object.assign, kt = (a) => {
  const t = X(a), r = a[a.indexOf($.LABEL) + $.LABEL.length], n = a[a.indexOf($.VALUE) + $.VALUE.length];
  return new RegExp(
    t.replace($.LABEL, `([^${X(r || "")}]+?)`).replace($.VALUE, `([^${X(n || "")}]+?)`)
  );
}, jt = (a) => {
  const r = X(a) + "(\\w*)";
  return new RegExp(r);
};
function we(a, t, r) {
  let n = a.replace($.LABEL, t);
  return r ? n.replace($.VALUE, r) : n;
}
function ar(a, t, ...r) {
  return new oe(r).split(a).reduce((i, c) => i += ie(c) ? t(c) : c, "");
}
const X = (a) => a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function He(a, t) {
  let r = "";
  for (let n of a)
    r += ie(n) ? we(t[n.childIndex].markup, n.label, n.value) : n;
  return r;
}
const At = (a, t) => a.annotation !== we(t, a.label, a.value) ? { ...a, label: a.value, value: a.label } : a, ne = (a, t = 0) => {
  let r = 3735928559 ^ t, n = 1103547991 ^ t;
  for (let i = 0, c; i < a.length; i++)
    c = a.charCodeAt(i), r = Math.imul(r ^ c, 2654435761), n = Math.imul(n ^ c, 1597334677);
  return r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), 4294967296 * (2097151 & n) + (r >>> 0);
}, ie = (a) => typeof a == "object", Dt = (a) => typeof a == "function", Nt = (a) => Ke(a) ? !0 : Ke(a == null ? void 0 : a[0]);
function It(a) {
  if (Nt(a))
    return mt.map(a, (r) => t(r.props));
  if (a != null && a.length)
    return a.map(t);
  return [Ge];
  function t(r) {
    return Re({}, Ge, r);
  }
}
const Lt = (a) => {
  const t = xe.createContext(void 0);
  t.displayName = a;
  const r = i(t), n = c(t);
  return [r, n];
  function i(v) {
    return () => {
      const u = bt(v);
      if (u)
        return u;
      throw new Error(`The context ${v.displayName} didn't found!`);
    };
  }
  function c(v) {
    return v.Provider;
  }
}, [se, Mt] = Lt("MarkedInputStoreProvider"), Vt = () => Z(() => new G(), []);
class G {
  constructor(t = NaN) {
    this._position = t;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(t, r) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const i = n.getRangeAt(0);
    i == null || i.setStart(t.firstChild || t, r), i == null || i.setEnd(t.firstChild || t, r);
  }
  static getCaretIndex(t) {
    let r = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return r;
    const i = n.getRangeAt(0), c = i.cloneRange();
    return c.selectNodeContents(t), c.setEnd(i.endContainer, i.endOffset), r = c.toString().length, r;
  }
  getPosition() {
    let t = this._position;
    return this._position = NaN, t;
  }
  setPosition(t) {
    this._position = t;
  }
  static setCaretToEnd(t) {
    const r = window.getSelection();
    r == null || r.setPosition(t, 1);
  }
  static getIndex() {
    var r;
    const t = window.getSelection();
    return (r = t == null ? void 0 : t.anchorOffset) != null ? r : NaN;
  }
  saveRightOffset() {
    var n, i;
    const t = window.getSelection(), r = (i = (n = t == null ? void 0 : t.anchorNode) == null ? void 0 : n.textContent) == null ? void 0 : i.length;
    this._position = r != null ? r : NaN;
  }
  restoreRightOffset() {
    var c, v;
    if (this.isBlurred)
      return;
    const t = window.getSelection(), r = t != null && t.rangeCount ? t.getRangeAt(0) : null;
    if (!(t != null && t.anchorNode))
      return;
    let n = (t == null ? void 0 : t.anchorNode.firstChild) || (t == null ? void 0 : t.anchorNode), i = ((v = (c = n == null ? void 0 : n.textContent) == null ? void 0 : c.length) != null ? v : 0) - this._position;
    r == null || r.setStart(n, i), r == null || r.setEnd(n, i), this.clear();
  }
  static setIndex1(t) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const n = r.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, t), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, t);
  }
  setCaretRightTo(t, r) {
    const n = window.getSelection(), i = n == null ? void 0 : n.getRangeAt(0);
    i == null || i.setStart(i.endContainer, r), i == null || i.setEnd(i.endContainer, r);
  }
}
const $t = (a) => {
  const t = ae(NaN);
  function r() {
    !a.current || (t.current = G.getCaretIndex(a.current));
  }
  function n() {
    !a.current || (G.setIndex(a.current, t.current), t.current = NaN);
  }
  return yt(() => {
    Number.isNaN(t.current) || n();
  }), r;
};
var W = /* @__PURE__ */ ((a) => (a[a.Change = 0] = "Change", a[a.Delete = 1] = "Delete", a))(W || {}), Ce = { exports: {} }, q = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var he, Je;
function Qe() {
  if (Je)
    return he;
  Je = 1;
  var a = Object.getOwnPropertySymbols, t = Object.prototype.hasOwnProperty, r = Object.prototype.propertyIsEnumerable;
  function n(c) {
    if (c == null)
      throw new TypeError("Object.assign cannot be called with null or undefined");
    return Object(c);
  }
  function i() {
    try {
      if (!Object.assign)
        return !1;
      var c = new String("abc");
      if (c[5] = "de", Object.getOwnPropertyNames(c)[0] === "5")
        return !1;
      for (var v = {}, u = 0; u < 10; u++)
        v["_" + String.fromCharCode(u)] = u;
      var d = Object.getOwnPropertyNames(v).map(function(l) {
        return v[l];
      });
      if (d.join("") !== "0123456789")
        return !1;
      var p = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(l) {
        p[l] = l;
      }), Object.keys(Object.assign({}, p)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return !1;
    }
  }
  return he = i() ? Object.assign : function(c, v) {
    for (var u, d = n(c), p, l = 1; l < arguments.length; l++) {
      u = Object(arguments[l]);
      for (var R in u)
        t.call(u, R) && (d[R] = u[R]);
      if (a) {
        p = a(u);
        for (var g = 0; g < p.length; g++)
          r.call(u, p[g]) && (d[p[g]] = u[p[g]]);
      }
    }
    return d;
  }, he;
}
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ze;
function Bt() {
  if (ze)
    return q;
  ze = 1, Qe();
  var a = xe, t = 60103;
  if (q.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
    var r = Symbol.for;
    t = r("react.element"), q.Fragment = r("react.fragment");
  }
  var n = a.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = Object.prototype.hasOwnProperty, c = { key: !0, ref: !0, __self: !0, __source: !0 };
  function v(u, d, p) {
    var l, R = {}, g = null, h = null;
    p !== void 0 && (g = "" + p), d.key !== void 0 && (g = "" + d.key), d.ref !== void 0 && (h = d.ref);
    for (l in d)
      i.call(d, l) && !c.hasOwnProperty(l) && (R[l] = d[l]);
    if (u && u.defaultProps)
      for (l in d = u.defaultProps, d)
        R[l] === void 0 && (R[l] = d[l]);
    return { $$typeof: t, type: u, key: g, ref: h, props: R, _owner: n.current };
  }
  return q.jsx = v, q.jsxs = v, q;
}
var Ee = {};
/** @license React v17.0.2
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Xe;
function Wt() {
  return Xe || (Xe = 1, function(a) {
    process.env.NODE_ENV !== "production" && function() {
      var t = xe, r = Qe(), n = 60103, i = 60106;
      a.Fragment = 60107;
      var c = 60108, v = 60114, u = 60109, d = 60110, p = 60112, l = 60113, R = 60120, g = 60115, h = 60116, b = 60121, A = 60122, O = 60117, S = 60129, P = 60131;
      if (typeof Symbol == "function" && Symbol.for) {
        var _ = Symbol.for;
        n = _("react.element"), i = _("react.portal"), a.Fragment = _("react.fragment"), c = _("react.strict_mode"), v = _("react.profiler"), u = _("react.provider"), d = _("react.context"), p = _("react.forward_ref"), l = _("react.suspense"), R = _("react.suspense_list"), g = _("react.memo"), h = _("react.lazy"), b = _("react.block"), A = _("react.server.block"), O = _("react.fundamental"), _("react.scope"), _("react.opaque.id"), S = _("react.debug_trace_mode"), _("react.offscreen"), P = _("react.legacy_hidden");
      }
      var k = typeof Symbol == "function" && Symbol.iterator, N = "@@iterator";
      function U(e) {
        if (e === null || typeof e != "object")
          return null;
        var o = k && e[k] || e[N];
        return typeof o == "function" ? o : null;
      }
      var L = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function T(e) {
        {
          for (var o = arguments.length, s = new Array(o > 1 ? o - 1 : 0), f = 1; f < o; f++)
            s[f - 1] = arguments[f];
          D("error", e, s);
        }
      }
      function D(e, o, s) {
        {
          var f = L.ReactDebugCurrentFrame, w = f.getStackAddendum();
          w !== "" && (o += "%s", s = s.concat([w]));
          var C = s.map(function(x) {
            return "" + x;
          });
          C.unshift("Warning: " + o), Function.prototype.apply.call(console[e], console, C);
        }
      }
      var H = !1;
      function et(e) {
        return !!(typeof e == "string" || typeof e == "function" || e === a.Fragment || e === v || e === S || e === c || e === l || e === R || e === P || H || typeof e == "object" && e !== null && (e.$$typeof === h || e.$$typeof === g || e.$$typeof === u || e.$$typeof === d || e.$$typeof === p || e.$$typeof === O || e.$$typeof === b || e[0] === A));
      }
      function tt(e, o, s) {
        var f = o.displayName || o.name || "";
        return e.displayName || (f !== "" ? s + "(" + f + ")" : s);
      }
      function be(e) {
        return e.displayName || "Context";
      }
      function I(e) {
        if (e == null)
          return null;
        if (typeof e.tag == "number" && T("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue."), typeof e == "function")
          return e.displayName || e.name || null;
        if (typeof e == "string")
          return e;
        switch (e) {
          case a.Fragment:
            return "Fragment";
          case i:
            return "Portal";
          case v:
            return "Profiler";
          case c:
            return "StrictMode";
          case l:
            return "Suspense";
          case R:
            return "SuspenseList";
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case d:
              var o = e;
              return be(o) + ".Consumer";
            case u:
              var s = e;
              return be(s._context) + ".Provider";
            case p:
              return tt(e, e.render, "ForwardRef");
            case g:
              return I(e.type);
            case b:
              return I(e._render);
            case h: {
              var f = e, w = f._payload, C = f._init;
              try {
                return I(C(w));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var J = 0, me, ye, Oe, Pe, Te, Se, ke;
      function je() {
      }
      je.__reactDisabledLog = !0;
      function rt() {
        {
          if (J === 0) {
            me = console.log, ye = console.info, Oe = console.warn, Pe = console.error, Te = console.group, Se = console.groupCollapsed, ke = console.groupEnd;
            var e = {
              configurable: !0,
              enumerable: !0,
              value: je,
              writable: !0
            };
            Object.defineProperties(console, {
              info: e,
              log: e,
              warn: e,
              error: e,
              group: e,
              groupCollapsed: e,
              groupEnd: e
            });
          }
          J++;
        }
      }
      function nt() {
        {
          if (J--, J === 0) {
            var e = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: r({}, e, {
                value: me
              }),
              info: r({}, e, {
                value: ye
              }),
              warn: r({}, e, {
                value: Oe
              }),
              error: r({}, e, {
                value: Pe
              }),
              group: r({}, e, {
                value: Te
              }),
              groupCollapsed: r({}, e, {
                value: Se
              }),
              groupEnd: r({}, e, {
                value: ke
              })
            });
          }
          J < 0 && T("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ue = L.ReactCurrentDispatcher, ce;
      function Q(e, o, s) {
        {
          if (ce === void 0)
            try {
              throw Error();
            } catch (w) {
              var f = w.stack.trim().match(/\n( *(at )?)/);
              ce = f && f[1] || "";
            }
          return `
` + ce + e;
        }
      }
      var le = !1, ee;
      {
        var at = typeof WeakMap == "function" ? WeakMap : Map;
        ee = new at();
      }
      function Ae(e, o) {
        if (!e || le)
          return "";
        {
          var s = ee.get(e);
          if (s !== void 0)
            return s;
        }
        var f;
        le = !0;
        var w = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var C;
        C = ue.current, ue.current = null, rt();
        try {
          if (o) {
            var x = function() {
              throw Error();
            };
            if (Object.defineProperty(x.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(x, []);
              } catch (V) {
                f = V;
              }
              Reflect.construct(e, [], x);
            } else {
              try {
                x.call();
              } catch (V) {
                f = V;
              }
              e.call(x.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (V) {
              f = V;
            }
            e();
          }
        } catch (V) {
          if (V && f && typeof V.stack == "string") {
            for (var E = V.stack.split(`
`), j = f.stack.split(`
`), m = E.length - 1, y = j.length - 1; m >= 1 && y >= 0 && E[m] !== j[y]; )
              y--;
            for (; m >= 1 && y >= 0; m--, y--)
              if (E[m] !== j[y]) {
                if (m !== 1 || y !== 1)
                  do
                    if (m--, y--, y < 0 || E[m] !== j[y]) {
                      var M = `
` + E[m].replace(" at new ", " at ");
                      return typeof e == "function" && ee.set(e, M), M;
                    }
                  while (m >= 1 && y >= 0);
                break;
              }
          }
        } finally {
          le = !1, ue.current = C, nt(), Error.prepareStackTrace = w;
        }
        var F = e ? e.displayName || e.name : "", Fe = F ? Q(F) : "";
        return typeof e == "function" && ee.set(e, Fe), Fe;
      }
      function De(e, o, s) {
        return Ae(e, !1);
      }
      function ot(e) {
        var o = e.prototype;
        return !!(o && o.isReactComponent);
      }
      function te(e, o, s) {
        if (e == null)
          return "";
        if (typeof e == "function")
          return Ae(e, ot(e));
        if (typeof e == "string")
          return Q(e);
        switch (e) {
          case l:
            return Q("Suspense");
          case R:
            return Q("SuspenseList");
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case p:
              return De(e.render);
            case g:
              return te(e.type, o, s);
            case b:
              return De(e._render);
            case h: {
              var f = e, w = f._payload, C = f._init;
              try {
                return te(C(w), o, s);
              } catch {
              }
            }
          }
        return "";
      }
      var Ne = {}, Ie = L.ReactDebugCurrentFrame;
      function re(e) {
        if (e) {
          var o = e._owner, s = te(e.type, e._source, o ? o.type : null);
          Ie.setExtraStackFrame(s);
        } else
          Ie.setExtraStackFrame(null);
      }
      function it(e, o, s, f, w) {
        {
          var C = Function.call.bind(Object.prototype.hasOwnProperty);
          for (var x in e)
            if (C(e, x)) {
              var E = void 0;
              try {
                if (typeof e[x] != "function") {
                  var j = Error((f || "React class") + ": " + s + " type `" + x + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[x] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw j.name = "Invariant Violation", j;
                }
                E = e[x](o, x, f, s, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (m) {
                E = m;
              }
              E && !(E instanceof Error) && (re(w), T("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", f || "React class", s, x, typeof E), re(null)), E instanceof Error && !(E.message in Ne) && (Ne[E.message] = !0, re(w), T("Failed %s type: %s", s, E.message), re(null));
            }
        }
      }
      var z = L.ReactCurrentOwner, fe = Object.prototype.hasOwnProperty, st = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, Le, Me, de;
      de = {};
      function ut(e) {
        if (fe.call(e, "ref")) {
          var o = Object.getOwnPropertyDescriptor(e, "ref").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.ref !== void 0;
      }
      function ct(e) {
        if (fe.call(e, "key")) {
          var o = Object.getOwnPropertyDescriptor(e, "key").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.key !== void 0;
      }
      function lt(e, o) {
        if (typeof e.ref == "string" && z.current && o && z.current.stateNode !== o) {
          var s = I(z.current.type);
          de[s] || (T('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', I(z.current.type), e.ref), de[s] = !0);
        }
      }
      function ft(e, o) {
        {
          var s = function() {
            Le || (Le = !0, T("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          s.isReactWarning = !0, Object.defineProperty(e, "key", {
            get: s,
            configurable: !0
          });
        }
      }
      function dt(e, o) {
        {
          var s = function() {
            Me || (Me = !0, T("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          s.isReactWarning = !0, Object.defineProperty(e, "ref", {
            get: s,
            configurable: !0
          });
        }
      }
      var pt = function(e, o, s, f, w, C, x) {
        var E = {
          $$typeof: n,
          type: e,
          key: o,
          ref: s,
          props: x,
          _owner: C
        };
        return E._store = {}, Object.defineProperty(E._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(E, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: f
        }), Object.defineProperty(E, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: w
        }), Object.freeze && (Object.freeze(E.props), Object.freeze(E)), E;
      };
      function vt(e, o, s, f, w) {
        {
          var C, x = {}, E = null, j = null;
          s !== void 0 && (E = "" + s), ct(o) && (E = "" + o.key), ut(o) && (j = o.ref, lt(o, w));
          for (C in o)
            fe.call(o, C) && !st.hasOwnProperty(C) && (x[C] = o[C]);
          if (e && e.defaultProps) {
            var m = e.defaultProps;
            for (C in m)
              x[C] === void 0 && (x[C] = m[C]);
          }
          if (E || j) {
            var y = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
            E && ft(x, y), j && dt(x, y);
          }
          return pt(e, E, j, w, f, z.current, x);
        }
      }
      var pe = L.ReactCurrentOwner, Ve = L.ReactDebugCurrentFrame;
      function Y(e) {
        if (e) {
          var o = e._owner, s = te(e.type, e._source, o ? o.type : null);
          Ve.setExtraStackFrame(s);
        } else
          Ve.setExtraStackFrame(null);
      }
      var ve;
      ve = !1;
      function ge(e) {
        return typeof e == "object" && e !== null && e.$$typeof === n;
      }
      function $e() {
        {
          if (pe.current) {
            var e = I(pe.current.type);
            if (e)
              return `

Check the render method of \`` + e + "`.";
          }
          return "";
        }
      }
      function gt(e) {
        {
          if (e !== void 0) {
            var o = e.fileName.replace(/^.*[\\\/]/, ""), s = e.lineNumber;
            return `

Check your code at ` + o + ":" + s + ".";
          }
          return "";
        }
      }
      var Be = {};
      function ht(e) {
        {
          var o = $e();
          if (!o) {
            var s = typeof e == "string" ? e : e.displayName || e.name;
            s && (o = `

Check the top-level render call using <` + s + ">.");
          }
          return o;
        }
      }
      function We(e, o) {
        {
          if (!e._store || e._store.validated || e.key != null)
            return;
          e._store.validated = !0;
          var s = ht(o);
          if (Be[s])
            return;
          Be[s] = !0;
          var f = "";
          e && e._owner && e._owner !== pe.current && (f = " It was passed a child from " + I(e._owner.type) + "."), Y(e), T('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', s, f), Y(null);
        }
      }
      function Ue(e, o) {
        {
          if (typeof e != "object")
            return;
          if (Array.isArray(e))
            for (var s = 0; s < e.length; s++) {
              var f = e[s];
              ge(f) && We(f, o);
            }
          else if (ge(e))
            e._store && (e._store.validated = !0);
          else if (e) {
            var w = U(e);
            if (typeof w == "function" && w !== e.entries)
              for (var C = w.call(e), x; !(x = C.next()).done; )
                ge(x.value) && We(x.value, o);
          }
        }
      }
      function Et(e) {
        {
          var o = e.type;
          if (o == null || typeof o == "string")
            return;
          var s;
          if (typeof o == "function")
            s = o.propTypes;
          else if (typeof o == "object" && (o.$$typeof === p || o.$$typeof === g))
            s = o.propTypes;
          else
            return;
          if (s) {
            var f = I(o);
            it(s, e.props, "prop", f, e);
          } else if (o.PropTypes !== void 0 && !ve) {
            ve = !0;
            var w = I(o);
            T("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", w || "Unknown");
          }
          typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && T("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function _t(e) {
        {
          for (var o = Object.keys(e.props), s = 0; s < o.length; s++) {
            var f = o[s];
            if (f !== "children" && f !== "key") {
              Y(e), T("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", f), Y(null);
              break;
            }
          }
          e.ref !== null && (Y(e), T("Invalid attribute `ref` supplied to `React.Fragment`."), Y(null));
        }
      }
      function Ye(e, o, s, f, w, C) {
        {
          var x = et(e);
          if (!x) {
            var E = "";
            (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (E += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
            var j = gt(w);
            j ? E += j : E += $e();
            var m;
            e === null ? m = "null" : Array.isArray(e) ? m = "array" : e !== void 0 && e.$$typeof === n ? (m = "<" + (I(e.type) || "Unknown") + " />", E = " Did you accidentally export a JSX literal instead of a component?") : m = typeof e, T("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", m, E);
          }
          var y = vt(e, o, s, w, C);
          if (y == null)
            return y;
          if (x) {
            var M = o.children;
            if (M !== void 0)
              if (f)
                if (Array.isArray(M)) {
                  for (var F = 0; F < M.length; F++)
                    Ue(M[F], e);
                  Object.freeze && Object.freeze(M);
                } else
                  T("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
              else
                Ue(M, e);
          }
          return e === a.Fragment ? _t(y) : Et(y), y;
        }
      }
      function xt(e, o, s) {
        return Ye(e, o, s, !0);
      }
      function Rt(e, o, s) {
        return Ye(e, o, s, !1);
      }
      var wt = Rt, Ct = xt;
      a.jsx = wt, a.jsxs = Ct;
    }();
  }(Ee)), Ee;
}
(function(a) {
  process.env.NODE_ENV === "production" ? a.exports = Bt() : a.exports = Wt();
})(Ce);
const B = Ce.exports.jsx, Ut = Ce.exports.jsxs, Yt = Ot(({
  id: a,
  value: t
}, r) => {
  const {
    dispatch: n,
    props: {
      readOnly: i,
      spanStyle: c,
      spanClassName: v
    }
  } = se(), u = ae(null);
  typeof r == "function" && r(u);
  const d = $t(u);
  return /* @__PURE__ */ B("span", {
    ref: u,
    style: c,
    className: v,
    contentEditable: !i,
    suppressContentEditableWarning: !0,
    onInput: (l) => {
      var g;
      d();
      const R = (g = l.currentTarget.textContent) != null ? g : "";
      n(W.Change, {
        key: a,
        value: R
      });
    },
    onPaste: Ft,
    children: t
  });
});
function Ft(a) {
  a.preventDefault();
  const t = a.clipboardData.getData("text");
  document.execCommand("insertText", !1, t);
}
const Kt = (a, t) => {
  const r = ae(null);
  return Pt(() => {
    var n;
    if (r.current) {
      let i = (n = t.current.get(r.current)) == null ? void 0 : n.current;
      i.focus();
      let c = a.getPosition();
      c && i && G.setIndex(i, c), r.current = null;
    }
  }), r;
}, qt = (a, t) => {
  const r = Vt(), n = {
    current: /* @__PURE__ */ new Map()
  }, {
    dispatch: i,
    sliceMap: c
  } = se(), v = [...c.keys()], u = ae(null), d = Kt(r, n), p = (h) => {
    var L, T;
    const b = h.target, A = G.getCaretIndex(b), O = A === 0, S = A === ((L = b.textContent) == null ? void 0 : L.length), P = {
      [K.LEFT]: O ? _ : null,
      [K.RIGHT]: S ? k : null,
      [K.UP]: null,
      [K.DOWN]: null,
      [K.DELETE]: S ? U : null,
      [K.BACKSPACE]: O ? N : null
    };
    (T = P[h.key]) == null || T.call(P);
    function _() {
      if (u.current && u.current !== 0) {
        let D = g()[u.current - 1].current;
        D == null || D.focus(), G.setCaretToEnd(D);
      }
      h.preventDefault();
    }
    function k() {
      var D;
      u.current !== null && u.current !== [...n.current.values()].length - 1 && ((D = g()[u.current + 1].current) == null || D.focus()), h.preventDefault();
    }
    function N() {
      if (u.current && u.current > 0) {
        d.current = l();
        let D = [...n.current.keys()][u.current], H = v.indexOf(D);
        i(W.Delete, {
          key: v[H - 1]
        });
      }
    }
    function U() {
      if (u.current !== null && u.current !== [...n.current.values()].length - 1) {
        d.current = R();
        let D = [...n.current.keys()][u.current], H = v.indexOf(D);
        i(W.Delete, {
          key: v[H + 1]
        });
      }
    }
  };
  function l() {
    var P, _, k, N;
    if (u.current === null)
      return null;
    let h = [...n.current.keys()][u.current - 1], b = [...n.current.keys()][u.current], A = (_ = (P = n.current.get(h)) == null ? void 0 : P.current) == null ? void 0 : _.textContent, O = (N = (k = n.current.get(b)) == null ? void 0 : k.current) == null ? void 0 : N.textContent, S = A + O;
    return r.setPosition(A.length), ne(S);
  }
  function R() {
    var P, _, k, N;
    if (u.current === null)
      return null;
    let h = [...n.current.keys()][u.current + 1], b = [...n.current.keys()][u.current], A = (_ = (P = n.current.get(h)) == null ? void 0 : P.current) == null ? void 0 : _.textContent, O = (N = (k = n.current.get(b)) == null ? void 0 : k.current) == null ? void 0 : N.textContent, S = O + A;
    return r.setPosition(O.length), ne(S);
  }
  function g() {
    return [...n.current.values()];
  }
  return {
    register: (h) => (b) => n.current.set(h, b),
    onFocus: (h) => {
      document.addEventListener("selectionchange", a), u.current = [...n.current.values()].findIndex((b) => b.current === h.target);
    },
    onBlur: () => {
      document == null || document.removeEventListener("selectionchange", a), setTimeout((h) => t(), 200), u.current = null;
    },
    onKeyDown: p
  };
}, Gt = () => {
  const {
    sliceMap: a,
    options: t,
    props: {
      Mark: r,
      ...n
    },
    trigger: {
      check: i,
      clear: c
    }
  } = se(), {
    register: v,
    ...u
  } = qt(i, c), d = n.className ? qe + " " + n.className : qe;
  return /* @__PURE__ */ B("div", {
    className: d,
    style: n.style,
    ...u,
    children: [...a].map(([p, l]) => {
      var g, h, b;
      if (!ie(l))
        return /* @__PURE__ */ B(Yt, {
          ref: v(p),
          id: p,
          value: l
        }, p);
      const R = (b = (h = (g = t[l.childIndex]).initMark) == null ? void 0 : h.call(g, l)) != null ? b : l;
      return /* @__PURE__ */ B(r, {
        tabIndex: -1,
        ...R
      }, p);
    })
  });
};
const Ht = (a) => Z(() => It(a), [a]), Jt = ({ value: a, onChange: t }, r) => {
  const n = Z(oe.split(a, r), [a]), i = Z(v, [n.length]), c = u();
  return [i, c];
  function v() {
    return n.reduce((p, l) => p.set(d(l, p), l), /* @__PURE__ */ new Map());
    function d(p, l) {
      let R = ie(p) ? p.label + p.value : p, g = 0, h = ne(R, g);
      for (; l.has(h); )
        h = ne(R, g++);
      return h;
    }
  }
  function u() {
    return _e((d, p) => {
      l(i, { type: d, payload: p });
      function l(R, g) {
        switch (g.type) {
          case W.Change:
            const { key: h, value: b = "" } = g.payload;
            R.set(h, b), t(He([...R.values()], r));
            break;
          case W.Delete:
            R.delete(g.payload.key), t(He([...R.values()], r));
            break;
          default:
            throw new Error();
        }
      }
    }, [i]);
  }
}, zt = (a) => {
  const [t, r] = Ze(), n = _e(() => r(void 0), []), i = _e(() => {
    var c;
    for (let v of a) {
      let {
        word: u,
        triggeredValue: d,
        text: p,
        indexBefore: l
      } = (c = Xt(v.trigger)) != null ? c : {};
      if (u !== void 0) {
        r({
          word: u,
          triggeredValue: d,
          style: Zt(),
          option: v,
          text: p,
          indexBefore: l
        });
        return;
      }
    }
    r(void 0);
  }, []);
  return Re({}, t, {
    check: i,
    clear: n
  });
};
function Xt(a) {
  var _, k, N, U;
  if (!a)
    return;
  const t = window.getSelection(), r = t == null ? void 0 : t.anchorOffset, n = (_ = t == null ? void 0 : t.anchorNode) == null ? void 0 : _.textContent;
  if (!r || !n)
    return;
  const i = n.slice(0, r), c = n.slice(r), u = X(a) + "\\w*$", d = new RegExp(u), p = new RegExp(/^\w*/), l = i.match(d), R = l == null ? void 0 : l.index, g = (k = l == null ? void 0 : l[0]) != null ? k : "", h = (U = (N = c.match(p)) == null ? void 0 : N[0]) != null ? U : "", b = g + h, O = jt(a).exec(b), S = O == null ? void 0 : O[0], P = O == null ? void 0 : O[1];
  if (P !== void 0)
    return {
      word: P,
      triggeredValue: S,
      text: n,
      indexBefore: R
    };
}
function Zt() {
  var t;
  const a = (t = window.getSelection()) == null ? void 0 : t.getRangeAt(0).getBoundingClientRect();
  return a ? {
    left: a.left,
    top: a.top + 20
  } : {
    left: 0,
    top: 0
  };
}
const Qt = (a) => {
  const t = Ht(a.children), [r, n] = Jt(a, t), i = zt(t);
  return {
    options: t,
    props: a,
    sliceMap: r,
    dispatch: n,
    trigger: i
  };
}, er = ({
  data: a,
  word: t,
  style: r,
  onSelect: n,
  ...i
}) => {
  const [c, v] = Ze(NaN), u = Z(() => a.filter((d) => d.toLowerCase().indexOf(t.toLowerCase()) > -1), [t]);
  return u.length ? /* @__PURE__ */ B("ul", {
    className: "mk-suggestions",
    style: r,
    children: u.map((d, p) => {
      let l;
      return p === c && (l = "mk-suggestion-active"), /* @__PURE__ */ B("li", {
        className: l,
        onClick: (R) => n({
          label: d,
          value: p.toString()
        }),
        children: d
      }, d);
    })
  }) : null;
}, tr = () => {
  var g, h;
  const {
    sliceMap: a,
    trigger: {
      word: t,
      option: r,
      style: n,
      text: i,
      indexBefore: c,
      triggeredValue: v
    },
    dispatch: u,
    props: {
      Overlay: d = er
    }
  } = se();
  if (t === void 0)
    return null;
  const l = {
    word: t,
    style: n,
    onSelect: ({
      label: b,
      value: A
    }) => {
      const O = we(r.markup, b, A);
      let S;
      for (let [_, k] of a.entries())
        if (k === i) {
          S = _;
          break;
        }
      let P = (i == null ? void 0 : i.slice(0, c)) + O + (i == null ? void 0 : i.slice(c + v.length));
      S && u(W.Change, {
        value: P,
        key: S
      });
    },
    data: r.data
  }, R = (h = (g = r.initOverlay) == null ? void 0 : g.call(r, l)) != null ? h : l;
  return Tt(d, R);
}, rr = (a) => {
  const t = Qt(a);
  return /* @__PURE__ */ Ut(Mt, {
    value: t,
    children: [/* @__PURE__ */ B(Gt, {}), /* @__PURE__ */ B(tr, {})]
  });
}, or = ({
  trigger: a = "@",
  markup: t = "@[__label__](__value__)",
  data: r = [],
  ...n
}) => null;
function ir(a, t, r) {
  const n = Dt(t) ? {
    Mark: a,
    Overlay: t,
    children: r
  } : {
    Mark: a,
    children: t
  };
  return (i) => {
    const c = Re({}, i, n);
    return rr(c);
  };
}
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.mk-input {
}
.mk-input span {
    outline: none;
    white-space: pre-wrap;
}

.mk-suggestions {
    border: 1px solid #ccc;
    max-height: 186px;
    overflow-y: auto;
    padding-left: 0;
    position: absolute;
    background: white;
    width: fit-content;
    min-width: 100px;

    transition: 1.1s ease-out;
    filter: blur(0);
    transform: scale(1);
    opacity: 1;
    visibility: visible;

    color: #000;
    border-radius: 4%;
    box-shadow: 0 3px 6px -2px rgba(0, 0, 0, 0.6);
}

.mk-suggestions li {
    padding: 0.5rem;
}

.mk-suggestions li:hover,
.mk-suggestion-active {
    background-color: #cce9ff;
    color: #2589f5;
    cursor: pointer;
}
`);
export {
  rr as MarkedInput,
  or as Option,
  we as annotate,
  ir as createMarkedInput,
  ar as denote
};
