export declare const useCaret: () => Caret;
/**
 * Restore caret on union for two spans
 */
export declare class Caret {
    private _position;
    constructor(_position?: number);
    get isBlurred(): boolean;
    clear(): void;
    static setIndex(element: HTMLElement, offset: number): void;
    static getCaretIndex(element: HTMLElement): number;
    getPosition(): number;
    setPosition(position: number): void;
    static setCaretToEnd(element: HTMLElement): void;
    static getIndex(): number;
    saveRightOffset(): void;
    restoreRightOffset(): void;
    static setIndex1(offset: number): void;
    setCaretRightTo(element: HTMLElement, offset: number): void;
}
//# sourceMappingURL=useCaret.d.ts.map