import { Mark } from "../types";
export declare class Matches implements IterableIterator<[string, Mark | null]> {
    raw: string;
    uniRegExp: RegExp;
    done: boolean;
    constructor(raw: string, uniRegExp: RegExp);
    [Symbol.iterator](): IterableIterator<[string, Mark | null]>;
    next(): IteratorResult<[string, Mark | null], [string, Mark | null] | null>;
    extractSlices(execArray: RegExpExecArray): [string, Mark, string];
    extractMark(execArray: RegExpExecArray): Mark;
}
//# sourceMappingURL=Matches.d.ts.map