import { ComponentType } from "react";
import { OptionProps } from "../../Option";
import { ConfiguredMarkedInput, MarkProps } from "../types";
/**
* Create the configured MarkedInput component.
*/
export declare function createMarkedInput<T>(Mark: ComponentType<T>, options: OptionProps<T>[]): ConfiguredMarkedInput<T>;
export declare function createMarkedInput<T extends MarkProps>(Mark: ComponentType<T>, options?: OptionProps<T>[]): ConfiguredMarkedInput<T>;
export declare function createMarkedInput<T, T1>(Mark: ComponentType<T>, Overlay: ComponentType<T1>, options: OptionProps<T, T1>[]): ConfiguredMarkedInput<T, T1>;
//# sourceMappingURL=createMarkedInput.d.ts.map